PRINT "Pyramids of Egypt level viewer by Frenkel Smeijers, 18-Juli-2002."
PRINT "frenkel_smeijers@hotmail.com"
PRINT "http://www.student.tue.nl/u/a.f.smeijers/sfp"
PRINT "http://www.sfprod.cjb.net"
PRINT

OPEN "pyramids.exe" FOR BINARY AS #1
IF LOF(1) = 0 THEN
  PRINT "Can't find PYRAMIDS.EXE"
  CLOSE #1
  KILL "pyramids.exe"
  END
ELSEIF LOF(1) = 66617 THEN
  PRINT "PYRAMIDS.EXE is compressed."
  PRINT "Uncompres with UNP.EXE"
  END
END IF

PRINT "Loading graphics may take some time."
PRINT "Press any key..."
DO: LOOP WHILE INKEY$ = ""

SEEK #1, 16902
DIM byte AS STRING * 1
DIM temp(0 TO 15, 0 TO 9) AS INTEGER
DIM temp2(0 TO 15, 0 TO 9) AS INTEGER
DIM wall(65) AS INTEGER
DIM wetwall(65) AS INTEGER
DIM drywall(65) AS INTEGER
DIM drywallright(65) AS INTEGER
DIM drywallleft(65) AS INTEGER
DIM diamond(65) AS INTEGER
DIM yellowwall(65) AS INTEGER
DIM door(65) AS INTEGER
DIM gas(65) AS INTEGER
DIM snake(65) AS INTEGER

DEF SEG = &HB800
FOR k% = 0 TO 22
  SCREEN 1
  OUT &H3C6, 0
  IF k% = 22 THEN SEEK #1, 17968
  GET #1, , iks%
  GET #1, , ei%
  FOR y% = 0 TO 10
    FOR x% = 0 TO 3
      GET #1, , byte
      POKE y% * 80 + x%, ASC(byte)
    NEXT x%
  NEXT y%
 
  FOR y% = 0 TO 9
    FOR x% = 0 TO 15
      temp(x%, y%) = POINT(x%, y% * 2)
      IF temp(x%, y%) = 0 THEN temp2(x%, y%) = 0
      IF temp(x%, y%) = 1 THEN temp2(x%, y%) = 12
      IF temp(x%, y%) = 2 THEN temp2(x%, y%) = 14
      IF temp(x%, y%) = 3 THEN temp2(x%, y%) = 15
    NEXT x%
  NEXT y%

  SCREEN 7, , 1, 0
  OUT &H3C6, 0
  FOR y% = 0 TO 9
    FOR x% = 0 TO 15
      PSET (x%, y%), temp2(x%, y%)
    NEXT x%
  NEXT y%

  IF k% = 0 THEN GET (0, 0)-(15, 9), wetwall
  IF k% = 1 THEN GET (0, 0)-(15, 9), drywall
  IF k% = 2 THEN GET (0, 0)-(15, 9), drywallright
  IF k% = 3 THEN GET (0, 0)-(15, 9), drywallleft
  IF k% = 4 THEN GET (0, 0)-(15, 9), diamond
  IF k% = 9 THEN GET (0, 0)-(15, 9), yellowwall
  IF k% = 10 THEN GET (0, 0)-(15, 9), door
  IF k% = 21 THEN GET (0, 0)-(15, 9), gas
  IF k% = 22 THEN GET (0, 0)-(15, 9), snake
  
NEXT k%
DEF SEG
OUT &H3C6, 255

level% = 1
showlevel:
CLS
SEEK #1, 38276 + level% * 512
FOR x% = 0 TO 19
  FOR y% = 0 TO 15
    GET #1, , byte
    IF ASC(byte) = 1 THEN PUT (x% * 16, y% * 10), drywall
    IF ASC(byte) = 2 THEN PUT (x% * 16, y% * 10), diamond
    IF ASC(byte) = 3 THEN PUT (x% * 16, y% * 10), gas
    IF ASC(byte) = 4 THEN PUT (x% * 16, y% * 10), wetwall
    IF ASC(byte) = 5 THEN PUT (x% * 16, y% * 10), door
    IF ASC(byte) = 6 THEN PUT (x% * 16, y% * 10), drywallleft
    IF ASC(byte) = 7 THEN PUT (x% * 16, y% * 10), yellowwall
    IF ASC(byte) = 8 THEN PUT (x% * 16, y% * 10), snake
    IF ASC(byte) = 9 THEN PUT (x% * 16, y% * 10), drywallright
  NEXT y%
NEXT x%
LINE (0, 160)-(319, 168), 12, BF
LOCATE 23, 1
PRINT "Level:"; level%
PCOPY 1, 0

DO
toets$ = INKEY$
IF toets$ = CHR$(0) + "M" THEN
  GOSUB clearkeyboardbuffer
  IF level% < 30 THEN
    level% = level% + 1
    GOTO showlevel
  END IF
ELSEIF toets$ = CHR$(0) + "K" THEN
  GOSUB clearkeyboardbuffer
  IF level% > 1 THEN
    level% = level% - 1
    GOTO showlevel
  END IF
ELSEIF toets$ = CHR$(27) THEN
  GOTO einde
END IF
LOOP

einde:
CLOSE #1
END

clearkeyboardbuffer:
DEF SEG = &H40
POKE &H1A, PEEK(&H1C)
POKE &H1B, PEEK(&H1D)
DEF SEG
RETURN

